-- D O C U M E N T   I N F O
-- Subject: LUA language script for a Blitzkrieg game
-- Mission type: single player
-- Mission designation: April 45
-- Created: April-2008
-- Author: Tronis
------------------------------------------------------------------------------------------------
--	Side	UNIT		Remark
-- 	0	200		6x Inf Squads (start group)
-- 	0	201		4x Tanks (start group)
-- 	0	202		1x Mobile Art (start group)
-- 	0	210		3x Inf Squads
-- 	0	215		Tank Group
-- 	0	216		Support Group (217 Sup / 218 Humans)
-- 	0	220		Artil Group
-- 	0	299		2x Support
-- 	0	300		Mixt Reinf
-- 	0	301		Heavy armour
-- 	1	214		AT Gun (Trigger to Reinf 215)
-- 	1	50		Auto Resup truck
-- 	1	51		Auto Suport truck
-- 	1	52		Auto Infantry patrol
-- 	1	55		Auto Reinf Group
-- 	1	56		Auto Reinf Group
-- 	1	57		Auto Reinf Group
-- 	1	60		3x Squads Reinf Group
-- 	1	500		Self Prop Artil Gun
--	1	501		Self Prop Artil Gun Resupply
--------------------------
-- : MISSION Objective # 0 -- Secrure the Warehouse
--------------------------
function Reveal_Obj_0()
	ObjectiveChanged(0,0);
	RunScript("InfantryReinf01",15000);
	RunScript("Reinf215",15000);
	RunScript("Patrol100",200000);
	Suicide();
end;
function Obj_0_DONE()
if GetNUnitsInArea(1,"Warehouse") == 0 and  GetNUnitsInArea(0,"Warehouse") >= 2 then
	ObjectiveChanged(0,1);
	SetIGlobalVar("OBJ00",1);
	RunScript("Pressure",8000);
	RunScript("Reinforcements",5000);
	RunScript("Defeat3",10000);
	Suicide();
end;
end;
--
function Reinforcements()
	RunScript("Reinf216",20000);
	RunScript("Reinf220",250000);
	RunScript("Reinf299",600000);
	RunScript("Reinf300",900000);
	RunScript("Reinf301",700000);
	Suicide();
end;
function Reinf299()
LandReinforcement(299);
Suicide();
end;
function Reinf300()
LandReinforcement(300);
Suicide();
end;
function Reinf301()
LandReinforcement(301);
Suicide();
end;
--
function InfantryReinf01()
if GetNUnitsInScriptGroup(200,0) < 3 then
	LandReinforcement(210);
	Suicide();
end;
end;
function Reinf215()
if GetNUnitsInScriptGroup(214,1) == 0 then
	LandReinforcement(215);
	Suicide();
end;
end;
function Reinf220()
LandReinforcement(220);
Suicide();
end;
function Reinf216()
LandReinforcement(216);
Suicide();
end;
------------------------------------------------------------------------------------------------
function CounterAttacksStatus()
	if GetNUnitsInArea(0,"HQ") == 0 and GetNUnitsInArea(1,"HQ") > 0 then
		SetIGlobalVar("AttackStatus",0);
	end;
	if GetNUnitsInArea(0,"HQ") > 0 and GetNUnitsInArea(1,"HQ") > 0 then
		SetIGlobalVar("AttackStatus",1);
	end;
	if GetNUnitsInArea(0,"HQ") > 0 and GetNUnitsInArea(1,"HQ") == 0 then
		SetIGlobalVar("AttackStatus",1);
	end;
	if GetNUnitsInArea(0,"HQ") == 0 and GetNUnitsInArea(1,"HQ") == 0 then
		SetIGlobalVar("AttackStatus",1);
	end;
end;
------------------------------------------------------------------------------------------------
function ResupTruck()
	if GetIGlobalVar("AttackStatus",0) == 0 and GetNUnitsInScriptGroup(50,1) == 0 then
		LandReinforcement(50);
	end;
end;
function SupportTruck()
	if GetIGlobalVar("AttackStatus",0) == 0 and GetNUnitsInScriptGroup(51,1) == 0 then
		LandReinforcement(51);
	end;
end;
function InfPatrol()
	if GetIGlobalVar("AttackStatus",0) == 0 and GetNUnitsInScriptGroup(52,1) == 0 then
		LandReinforcement(52);
	end;
end;
function Patrol100()
 local PatrolID = 52;
 local PATROL1 = 0;
	if GetNScriptUnitsInArea(PatrolID,"HQ") > 0 then
		Cmd(3,PatrolID,GetScriptAreaParams("P01"));
		QCmd(3,PatrolID,GetScriptAreaParams("P04"));
		QCmd(3,PatrolID,GetScriptAreaParams("P02"));
		local PATROL1 = 1
	elseif GetNScriptUnitsInArea(PatrolID,"P02") > 0 then
		Cmd(3,PatrolID,GetScriptAreaParams("HQ"));
		local PATROL1 = 0
	end;
end;
------------------------------------------------------------------------------------------------
function ReplaceLRA()
	if GetNUnitsInArea(0,"EnemyLand") == 0 and GetNUnitsInArea(1,"EnemyLand") > 0 then
		SetIGlobalVar("LRA",0);
	end;
	if GetNUnitsInArea(0,"EnemyLand") > 0 and GetNUnitsInArea(1,"EnemyLand") > 0 then
		SetIGlobalVar("LRA",1);
	end;
	if GetNUnitsInArea(0,"EnemyLand") > 0 and GetNUnitsInArea(1,"EnemyLand") == 0 then
		SetIGlobalVar("LRA",1);
	end;
	if GetNUnitsInArea(0,"EnemyLand") == 0 and GetNUnitsInArea(1,"EnemyLand") == 0 then
		SetIGlobalVar("LRA",1);
	end;
end;
--
function ReplaceHummel()
	if GetIGlobalVar("LRA",0) == 0 and GetNUnitsInScriptGroup(500,1) == 0 then
		LandReinforcement(500);
	end;
end;
function ReplaceHummelAmmo()
	if GetIGlobalVar("LRA",0) == 0 and GetNUnitsInScriptGroup(501,1) == 0 then
		LandReinforcement(501);
	end;
end;
function ReplaceCalliope()
	if GetIGlobalVar("LRA",0) == 0 and GetNUnitsInScriptGroup(502,1) == 0 then
		LandReinforcement(502);
	end;
end;
function ReplaceCalliopeAmmo()
	if GetIGlobalVar("LRA",0) == 0 and GetNUnitsInScriptGroup(503,1) == 0 then
		LandReinforcement(503);
	end;
end;
------------------------------------------------------------------------------------------------
function Pressure()
	RunScript("AttackGroup",600000);
	RunScript("MorePressure",1200000);
	Suicide();
end;
function MorePressure()
	RunScript("AttackGroup",10000);
	RunScript("EvenMorePressure",600000);
	Suicide();
end;
function EvenMorePressure()
	RunScript("AttackGroup",10000);
	RunScript("FinalPressure",600000);
	Suicide();
end;
function FinalPressure()
	RunScript("AttackGroup",10000);
	RunScript("LastPressure",600000);
	Suicide();
end;
function LastPressure()
	RunScript("AttackGroup",10000);
	Suicide();
end;

function AttackGroup()
	if (GetNUnitsInArea(1,"RightLINE") + GetNUnitsInArea(1,"LeftLINE") > 0) and (GetNUnitsInArea(0,"RightLINE") + GetNUnitsInArea(0,"LeftLINE") == 0) then
		LandReinforcement(60);
		RunScript("SelectReinfGroup",30000);
		Suicide();
	end;
end;
function Patrol60()
local PatrolID = 60;
local PATROL1 = 0;
	if GetNScriptUnitsInArea(PatrolID,"HQ") > 0 then
		Cmd(3,PatrolID,GetScriptAreaParams("RightLINE"));
		QCmd(3,PatrolID,GetScriptAreaParams("P01"));
		QCmd(3,PatrolID,GetScriptAreaParams("P04"));
		local PATROL1 = 1
	elseif GetNScriptUnitsInArea(PatrolID,"P04") > 0 then
		Cmd(3,PatrolID,GetScriptAreaParams("HQ"));
		local PATROL1 = 0
	end;
end;
function SelectReinfGroup()
SetIGlobalVar("Select",RandomInt(4));
	if GetIGlobalVar("Select",0) == 1 then
		LandReinforcement(55);
		Suicide();
	elseif GetIGlobalVar("Select",0) == 2 then
		LandReinforcement(56);
		Suicide();
	elseif GetIGlobalVar("Select",0) == 3 then
		LandReinforcement(57);
		Suicide();
	end;
end;
--------------------------
-- : MISSION Objective # 1 -- Fuel Depot
--------------------------
function Reveal_Obj_1()
	ObjectiveChanged(1,0);
	Suicide();
end;
function Obj_1_DONE()
 if GetNUnitsInArea(1,"FuelDeposit") == 0 and  GetNUnitsInArea(0,"FuelDeposit") >= 2 then
	ObjectiveChanged(1,1);
	SetIGlobalVar("OBJ01",1);
	LandReinforcement(210);
	Suicide();
 end;
end;
--------------------------
-- : MISSION Objective # 2 -- Secure the HQ
--------------------------
function Reveal_Obj_2()
	ObjectiveChanged(2,0);
	Suicide();
end;
function Obj_2_DONE()
	if GetNUnitsInArea(1,"HQ") == 0 and  GetNUnitsInArea(0,"HQ") >= 2 then
		ObjectiveChanged(2,1);
		SetIGlobalVar("OBJ02",1);
		Suicide();
	end;
end;
--------------------------
-- : WIN / LOOSE
--------------------------
function WinMission()
if GetIGlobalVar("OBJ00",0) * GetIGlobalVar("OBJ01",0) * GetIGlobalVar("OBJ02",0) == 1 then
	Win(0);
	KillScript("Defeat1");
	KillScript("Defeat2");
	KillScript("Defeat3");
	KillScript("Defeat4");
	Suicide();
end;
end;
function LooseMission()
	RunScript("Defeat1",5000);
	RunScript("Defeat2",10000);
	RunScript("Defeat4",3800000);
	Suicide();
end;
function Defeat1()
	if GetNUnitsInSide(0) < 4 then
		DisplayTrace("You are an incompetent officer! We can not trust more men in your command!")
		Loose();
		Suicide();
	end;
end;
function Defeat2()
	if GetNUnitsInArea(1,"WayIn") > 3 and GetNUnitsInArea(0,"WayIn") < 2 then
		DisplayTrace("The enemy has been able to get into your operational area!")
		Loose();
		Suicide();
	end;
end;
function Defeat3()
	if GetNUnitsInArea(1,"Warehouse") > 3 and GetNUnitsInArea(0,"Warehouse") < 2 then
		DisplayTrace("The enemy has been able to get into your logistics area!")
		Loose();
		Suicide();
	end;
end;
function Defeat4()
	DisplayTrace("You are dismissed! We cant loose any more time with your disastrous manouvers! History cant wait for you!");
	Loose();	
	Suicide();
end;
-------------------
-- INITIALIZATION
-------------------
function Init()
	RunScript("MissionVariables",4000);
	RunScript("Debug",3000);
	RunScript("Reveal_Obj_0",5000);
	RunScript("Reveal_Obj_1",10000);
	RunScript("Reveal_Obj_2",15000);
	RunScript("Obj_0_DONE",10000);
	RunScript("Obj_1_DONE",15000);
	RunScript("Obj_2_DONE",20000);
	RunScript("CounterAttacksStatus",10000);
	RunScript("ResupTruck",15000);
	RunScript("SupportTruck",16000);
	RunScript("ReplaceLRA",10000);
	RunScript("ReplaceHummel",20000);
	RunScript("ReplaceHummelAmmo",20000);
	RunScript("ReplaceCalliope",20000);
	RunScript("ReplaceCalliopeAmmo",20000);
	RunScript("InfPatrol",17000);
	RunScript("Patrol60",10000);
	RunScript("WinMission",15000);
	RunScript("LooseMission",20000);
end;
---------------------------------------------------
function MissionVariables()
	SetIGlobalVar("OBJ00",0);
	SetIGlobalVar("OBJ01",0);
	SetIGlobalVar("OBJ02",0);
	Suicide();
end;
function Debug()
	DisplayTrace("A new mission, another adventure...");
	Password("Panzerklein");
	-- God(0,1);
	-- ChangeWarFog(1);
	Suicide();
end;
-------------- :: eof - Tronis/2008 :: --------------